package kaysaar.aotd_question_of_loyalty.data.scripts.trackers;

import java.util.ArrayList;
import com.fs.starfarer.api.Global;
import java.util.Iterator;
import java.util.List;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;
import com.fs.starfarer.api.impl.campaign.intel.events.EventFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.eventfactors.onetime.BountyCompletionFactor;
import kaysaar.aotd_question_of_loyalty.data.intel.AoTDCommIntelPlugin;
import org.magiclib.bounty.MagicBountySpec;
import org.magiclib.bounty.MagicBountyLoader;
import org.magiclib.bounty.MagicBountyCoordinator;
import kaysaar.aotd_question_of_loyalty.data.misc.QoLMisc;
import com.fs.starfarer.api.EveryFrameScript;

public class MagicLibBountyTracker implements EveryFrameScript
{
    public static String memKeyForAlreadyChecked;
    
    public boolean isDone() {
        return false;
    }
    
    public boolean runWhilePaused() {
        return false;
    }
    
    public void advance(final float amount) {
        if (!QoLMisc.isCommissioned()) {
            return;
        }
        final List<String> alreadyDoneQuests = this.getAlreadyDoneFromMemory();
        for (final String completedBounty : MagicBountyCoordinator.getInstance().getCompletedBounties()) {
            if (alreadyDoneQuests.contains(completedBounty)) {
                continue;
            }
            if (MagicBountyLoader.BOUNTIES.get(completedBounty) == null) {
                continue;
            }
            if (this.haveSucceededBounty(MagicBountyLoader.BOUNTIES.get(completedBounty).job_memKey) && QoLMisc.isCommissionedBy(MagicBountyLoader.BOUNTIES.get(completedBounty).job_forFaction)) {
                final int factor = 10000;
                final int value = MagicBountyLoader.BOUNTIES.get(completedBounty).job_credit_reward / factor;
                AoTDCommIntelPlugin.get().addFactor((EventFactor)new BountyCompletionFactor(value), (InteractionDialogAPI)null);
                alreadyDoneQuests.add(completedBounty);
            }
            if (!this.haveFailedBounty(MagicBountyLoader.BOUNTIES.get(completedBounty).job_memKey) || !QoLMisc.isCommissionedBy(MagicBountyLoader.BOUNTIES.get(completedBounty).job_forFaction)) {
                continue;
            }
            final int factor = 20000;
            final int value = MagicBountyLoader.BOUNTIES.get(completedBounty).job_credit_reward / factor;
            AoTDCommIntelPlugin.get().addFactor((EventFactor)new BountyCompletionFactor(-value), (InteractionDialogAPI)null);
            alreadyDoneQuests.add(completedBounty);
        }
        this.updateMemory(alreadyDoneQuests);
    }
    
    public List<String> getAlreadyDoneFromMemory() {
        if (Global.getSector().getMemoryWithoutUpdate().contains(MagicLibBountyTracker.memKeyForAlreadyChecked)) {
            return (List)Global.getSector().getMemory().get(MagicLibBountyTracker.memKeyForAlreadyChecked);
        }
        return new ArrayList<String>();
    }
    
    public void updateMemory(final List<String> toUpdate) {
        Global.getSector().getMemory().set(MagicLibBountyTracker.memKeyForAlreadyChecked, (Object)toUpdate);
    }
    
    public boolean haveSucceededBounty(final String memKeyForAlreadyChecked) {
        return Global.getSector().getMemoryWithoutUpdate().contains(memKeyForAlreadyChecked + "_succeeded");
    }
    
    public boolean haveFailedBounty(final String memKeyForAlreadyChecked) {
        return Global.getSector().getMemoryWithoutUpdate().contains(memKeyForAlreadyChecked + "_failed");
    }
    
    static {
        MagicLibBountyTracker.memKeyForAlreadyChecked = "$aotd_magic_already_checked";
    }
}
